// Code generated by pggen. DO NOT EDIT.

package domain

import (
	"context"
	"fmt"
	"github.com/jackc/pgconn"
	"github.com/jackc/pgx/v4"
)

// Querier is a typesafe Go interface backed by SQL queries.
//
// Methods ending with Batch enqueue a query to run later in a pgx.Batch. After
// calling SendBatch on pgx.Conn, pgxpool.Pool, or pgx.Tx, use the Scan methods
// to parse the results.
type Querier interface {
	DomainOne(ctx context.Context) (string, error)
	// DomainOneBatch enqueues a DomainOne query into batch to be executed
	// later by the batch.
	DomainOneBatch(batch *pgx.Batch)
	// DomainOneScan scans the result of an executed DomainOneBatch query.
	DomainOneScan(results pgx.BatchResults) (string, error)
}

type DBQuerier struct {
	conn genericConn
}

var _ Querier = &DBQuerier{}

// genericConn is a connection to a Postgres database. This is usually backed by
// *pgx.Conn, pgx.Tx, or *pgxpool.Pool.
type genericConn interface {
	// Query executes sql with args. If there is an error the returned Rows will
	// be returned in an error state. So it is allowed to ignore the error
	// returned from Query and handle it in Rows.
	Query(ctx context.Context, sql string, args ...interface{}) (pgx.Rows, error)

	// QueryRow is a convenience wrapper over Query. Any error that occurs while
	// querying is deferred until calling Scan on the returned Row. That Row will
	// error with pgx.ErrNoRows if no rows are returned.
	QueryRow(ctx context.Context, sql string, args ...interface{}) pgx.Row

	// Exec executes sql. sql can be either a prepared statement name or an SQL
	// string. arguments should be referenced positionally from the sql string
	// as $1, $2, etc.
	Exec(ctx context.Context, sql string, arguments ...interface{}) (pgconn.CommandTag, error)
}

// NewQuerier creates a DBQuerier that implements Querier. conn is typically
// *pgx.Conn, pgx.Tx, or *pgxpool.Pool.
func NewQuerier(conn genericConn) *DBQuerier {
	return &DBQuerier{
		conn: conn,
	}
}

// WithTx creates a new DBQuerier that uses the transaction to run all queries.
func (q *DBQuerier) WithTx(tx pgx.Tx) (*DBQuerier, error) {
	return &DBQuerier{conn: tx}, nil
}

const domainOneSQL = `SELECT '90210'::us_postal_code;`

// DomainOne implements Querier.DomainOne.
func (q *DBQuerier) DomainOne(ctx context.Context) (string, error) {
	row := q.conn.QueryRow(ctx, domainOneSQL)
	var item string
	if err := row.Scan(&item); err != nil {
		return item, fmt.Errorf("query DomainOne: %w", err)
	}
	return item, nil
}

// DomainOneBatch implements Querier.DomainOneBatch.
func (q *DBQuerier) DomainOneBatch(batch *pgx.Batch) {
	batch.Queue(domainOneSQL)
}

// DomainOneScan implements Querier.DomainOneScan.
func (q *DBQuerier) DomainOneScan(results pgx.BatchResults) (string, error) {
	row := results.QueryRow()
	var item string
	if err := row.Scan(&item); err != nil {
		return item, fmt.Errorf("scan DomainOneBatch row: %w", err)
	}
	return item, nil
}
